<?php

/***************************\
 * Clariphony (c) clarisys *
 *                         *
\***************************/

class clariphony extends pgsql {
   
	 /* Constructeur */
	 /* initialise la base de donne */
   function clariphony ()
	 {
     return $this->Init_db (constant("DB_HOST"),constant("DB_USER"),constant("DB_PASS"),constant("DB_BASE"));
	 }
	

	 /* rcupere l'id d'un appelant avec son code */
   function Search_NameId_By_Code($code)
	 {
     $Query  = "SELECT id_appelant,nom FROM appelant ";
		 $Query .= "WHERE code ILIKE '%".$code."%'";
     $this->QueryRow($Query);
		 if (!$this->HasResult()) { return False; }
		 return $this->data["nom"];
	 }
	 

	 /* rcupere l'id d'un appelant avec son nom */
   function Get_Id_By_Name ($nom)
	 {
     $keywords = explode(" ",$nom);
		 if (count($keywords)==1)
		 {
       $Query  = "SELECT id_appelant FROM appelant WHERE nom ILIKE '%".$nom."%'";
		 } else {
       $Query  = "SELECT id_appelant FROM appelant WHERE 0=0 ";
			 for ($i=0;$i<count($keywords);$i++)
			 {
			   $Query .= "AND nom ILIKE '%".$keywords[$i]."%' ";
			 }
		 }
		 $this->QueryRow($Query);
		 return $this->data["id_appelant"];
	 }
	 

	 /* ajoute une notification avec le nom de l'appelant */
   function AddNoteNom($nom,$tel,$priorite,$message,$rappel)
	 {
		 $nom = trim($nom);
     return $this->InsertNote($this->Get_Id_By_Name($nom),$tel,$priorite,$message,$rappel);
	 }
	 

	 /* ajoute une notification avec le code de l'appelant */
 	 function AddNoteCode($code,$tel,$priorite,$message,$rappel)
	 {
     $code = trim($code);
		 if (!($nom = $this->Search_NameId_By_Code($code))) {
			 Debug(3,"Code ".$code." introuvable.");
			 return False;
		 }
		 return $this->InsertNote($this->Get_Id_By_Name($nom),$tel,$priorite,$message,$rappel);
	 }
	 

	 /* Insere une notification dans la base de donne */
   function InsertNote($id_appelant,$tel,$id_priorite,$message,$rappel)
	 {
		 $id_operateur = $_SESSION["id_operateur"];
     $Query  = "INSERT INTO notification (id_appelant,tel_rappel,id_priorite, ";
		 $Query .= "contenu,a_rappeler,date_appel,id_operateur) ";
		 $Query .= "VALUES (".$id_appelant.",'".$tel."',".$id_priorite.",'".$message."','".$rappel."',now(),".$id_operateur.")";
		 if (!$this->Insert($Query)) { return False; }
		 $Query  = "SELECT currval('public.notification_id_notification_seq'::text) AS id";
		 $this->QueryRow($Query);
		 $this->Send_Mail($this->data["id"]);
		 return True;
	 }
	 
	 /* Rcupere la liste des priorites */
   function Get_Priorites()
	 {
     $Query  = "SELECT * FROM priorite ORDER BY poids DESC";
		 $this->Query($Query);
		 $i=0;
		 $prio = array ();
		 while($this->HasNext())
		 {
				$prio[$i]["libelle"] = $this->data["libelle"];
				$prio[$i]["id"]      = $this->data["id_priorite"];
				$i++;
		 }
		 return $prio;
	 }
	 

	 /* Rcupere une notification grave a son id */
   function Get_Note($id)
	 {
		 $Query  = "SELECT n.*, a.nom AS nom, to_char(date_appel,'le DD/MM  HH24:MIh') AS date, ";
		 $Query .= "op.nom AS operateur, op2.nom AS op_rap, a.tel AS tel_appelant, s.tel AS tel_societe, ";
		 $Query .= "p.libelle AS priorite, s.nom AS societe, op.email AS mail_operateur ";
		 $Query .= "FROM notification n LEFT JOIN operateur op2 ON op2.id_operateur=n.id_transfert, ";
		 $Query .= "operateur op, societe s, appelant a, priorite p ";
		 $Query .= "WHERE a.id_appelant=n.id_appelant AND s.id_societe=a.id_societe AND id_notification='".$id."' ";
		 $Query .= "AND op.id_operateur=n.id_operateur AND p.id_priorite=n.id_priorite";
		 $this->QueryRow($Query);
		 if ($this->data["tel_rappel"] != NULL)
		 {
			 $this->data["tel"] = $this->data["tel_rappel"]." (N)";
		 } else if ($this->data["tel_appelant"] != NULL) {
			 $this->data["tel"] = $this->data["tel_appelant"]." (A)";
		 } else {
       $this->data["tel"] = $this->data["tel_societe"]." (S)";
		 }
		 return $this->data;
	 }
	 
	 /* Marquer une notification comme "lue" */
	 function Mark_Read($id)
	 {
     $id_operateur = $_SESSION["id_operateur"];		 
 		 $Query  = "UPDATE notification SET rappel_ok='t',id_transfert='".$id_operateur."',date_rappel=now() ";
		 $Query .= "WHERE id_notification='".$id."'";
		 return $this->Update($Query);
	 }
	 
	 function List_Notifications ($order="rappel_ok ASC, a_rappeler DESC, poids DESC, date_appel DESC")
	 {
     return $this->List_Notifs(0,$order);
	 }
	 
	 function List_A_Rappeler($order="rappel_ok ASC, a_rappeler DESC, poids DESC, date_appel DESC")
	 {
     return $this->List_Notifs(1,$order);
	 }
	 
	 /* Liste toute les notifications 
	  * Si le premier argument est 0, rcupere tout les appels entrants
		* si il est position sur 1, rcupere que les appels a rappeler
		*/
   function List_Notifs ($rappel,$order="rappel_ok ASC, a_rappeler DESC, poids DESC, date_appel DESC")
	 {
		 $Query  = "SELECT n.date_appel,a.nom,n.id_notification,n.date_appel,n.id_appelant,n.id_operateur, ";
		 $Query .= "to_char(date_appel,'DD/MM HH24:MIh') AS date, ";
		 $Query .= "n.id_priorite, n.a_rappeler, n.rappel_ok, n.date_rappel, n.tel_rappel, ";
		 $Query .= "n.contenu, n.id_transfert, ";
		 $Query .= "s.nom AS societe, p.libelle AS priorite, p.poids AS poids, a.tel AS tel_appelant, ";
		 $Query .= "s.tel AS tel_societe, o.code AS operateur ";
		 $Query .= "FROM societe s, operateur o, priorite p, ";
		 $Query .= "notification n INNER JOIN appelant a USING (id_appelant) ";
		 $Query .= "WHERE s.id_societe=a.id_societe AND p.id_priorite=n.id_priorite ";
		 $Query .= "AND o.id_operateur=n.id_operateur ";
		 if ($rappel == 1) {
       $Query .= "AND rappel_ok='f' AND a_rappeler='t' ";
		 }
		 $Query .= "ORDER BY ".$order;
		 $this->Query($Query);
		 $notifications = array ();
		 $i=0;
		 while ($this->HasNext())
		 {
       $notifications[$i]["nom"]        = $this->data["nom"];
			 $notifications[$i]["email"]      = $this->data["email"];
			 if ($this->data["tel_rappel"] != NULL) {
				 $notifications[$i]["tel"]     	= $this->data["tel_rappel"] . " (N)";
			 } else if ($this->data["tel_appelant"] != NULL) {
			   $notifications[$i]["tel"]      = $this->data["tel_appelant"] . " (A)";
			 } else if ($this->data["tel_societe"] != NULL) {
				 $notifications[$i]["tel"]      = $this->data["tel_societe"] . " (S)";
			 } else {
				 $notifications[$i]["tel"]      = "";
			 }
       $notifications[$i]["tel"]        = $this->Format_Tel($notifications[$i]["tel"]);
			 $notifications[$i]["contenu"]    = $this->data["contenu"];
			 if (($this->data["a_rappeler"] == "t") and ($this->data["rappel_ok"] == "f"))
			 {
				 $notifications[$i]["rappel"] = "t";
			 } else { 
				 $notifications[$i]["rappel"] = "f";
			 }
			 $notifications[$i]["date"]       = $this->data["date"];
			 $notifications[$i]["operateur"]  = $this->data["operateur"];
			 $notifications[$i]["societe"]    = $this->data["societe"];
 		   $notifications[$i]["priorite"]   = $this->data["priorite"];
			 $notifications[$i]["id"]         = $this->data["id_notification"];
			 $i++;
		 } 
		 return $notifications;
	 }
	 
	 /* recherche un appelant par son nom ou son code */
   function Search_appelant($search) {
		 $search = trim($search);
		 $keywords = explode(" ",$search);
		 $Query  = "SELECT a.*, s.tel AS tel_societe, s.nom AS societe ";
		 $Query .= "FROM appelant a, societe s WHERE a.id_societe=s.id_societe ";
		 if (count($keywords)>1)
		 {
       for ($i=0;$i<count($keywords);$i++)
       {
         $Query .= "AND (a.nom ILIKE '%".$keywords[$i]."%' OR a.code ILIKE '%".$keywords[$i]."%') ";
	     }
		 } else {
		   $Query .= "AND (a.code ILIKE '%".$search."%' OR a.nom ILIKE '%".$search."%') ";
		 }
		 $this->Query($Query);
		 $i=0;
		 $result = array ();
		 while ($this->HasNext())
		 {
		   $result[$i]["nom"]         = $this->data["nom"];
			 if ($this->data["tel"] == NULL)
			 {
				 $result[$i]["tel"]       = $this->data["tel_societe"]." (S)";
			 } else {
				 $result[$i]["tel"]         = $this->data["tel"]." (A)";
			 }
			 $result[$i]["tel"]         = $this->Format_Tel($result[$i]["tel"]);
			 $result[$i]["id_societe"]  = $this->data["id_societe"];
			 $result[$i]["societe"]     = $this->data["societe"];
			 $result[$i]["email"]       = $this->data["email"];
			 $result[$i]["code"]        = $this->data["code"];
			 $result[$i]["id"]					= $this->data["id_appelant"];
			 $i++;
		 }
		 return $result;
 	 }
	 
	 /* retourne une liste de socites dans la base */
   function List_Societes()
	 {
     $Query  = "SELECT * FROM societe ORDER BY nom ASC";
		 $this->Query($Query);
		 $societe = array();
		 $i=0;
		 while ($this->HasNext())
		 {
       $societe[$i]["nom"]      = $this->data["nom"];
			 $societe[$i]["tel"]      = $this->Format_Tel($this->data["tel"]);
			 $societe[$i]["code"]     = $this->data["code"];
			 $societe[$i]["id"]       = $this->data["id_societe"];
			 $societe[$i]["client"]   = $this->data["client"];
			 $i++;
     }
		 return $societe;
	 }

	 /* Rcupere une socit en fonction de son id */
	 function Get_Societe($id)
	 {
     $Query  = "SELECT * FROM societe WHERE id_societe='".$id."'";
		 if (!$this->QueryRow($Query)) { return False; }
		 return $this->data;
	 }
	 
	 /* modifie les donnes d'une socit */
   function modifysociete($id_societe,$nom,$tel,$code,$client)
	 {
		 $Query  = "UPDATE societe SET nom='".$nom."',tel='".$tel."',code='".$code."',client='".$client."' ";
		 $Query .= "WHERE id_societe='".$id_societe."'";
		 return $this->Update($Query);
	 }

   function delsociete($id)
   {
     if (!is_numeric($id)) { return False; }
     $Query = "DELETE FROM societe WHERE id_societe='".$id."'";
     return $this->Delete($Query);
   } 
									 
	 
	 function Add_Societe($nom,$tel,$code,$client)
	 {
		 $Query  = "INSERT INTO societe (nom,tel,code,client) ";
		 $Query .= "VALUES ('".$nom."','".$tel."','".$code."','".$client."')";
		 if (!$this->Insert($Query)) { return False; }
		 $Query  = "INSERT INTO appelant (id_societe,nom) ";
		 $Query .= "VALUES (currval('public.societe_id_societe_seq'),'".$nom."')";
		 return $this->Insert($Query);
	 }
	
	 /* retourne l'id d'une socit cherche */
	 function Get_Societe_Id($societe)
	 {
     $Query  = "SELECT id_societe FROM societe WHERE nom ILIKE '%".$societe."%'";
		 $this->QueryRow($Query);
		 if (!$this->HasResult()) { return False; }
		 return $this->data["id_societe"];
	 }
	 
	 /* Formatte un numro de telephone
	  * exemple 0561345623 deviendra 05 61 34 56 23
		*/
   function Format_Tel ($tel)
	 {
     return ereg_replace("([0-9]{2})([0-9]{2})([0-9]{2})([0-9]{2})([0-9]{2})(.*)", "\\1 \\2 \\3 \\4 \\5 \\6", $tel);
	 }
	 
	 /* cette fonction ajoute un appelant a la base de donne,
	  * certains champs peuvent etre nuls, il ne faut pas 
		* s'tonner si a leur entre ils sont nuls dans la base 
		* de donne.
		*/
   function addappelant($nom,$societe,$tel,$email,$code)
	 {
     $Query  = "INSERT INTO appelant ";
		 $Query .= "(nom,id_societe,tel,email,code) VALUES ";
		 $Query .= "('".$nom."','".$societe."','".$tel."','".$email."','".$code."') ";
		 return $this->Insert($Query);
	 }
	 
	 /* Cette fonction retourne la liste des appelants */
   function List_Appelants()
	 {
		 $Query  = "SELECT a.nom, a.tel, a.code, a.id_appelant, a.email, a.id_societe, ";
		 $Query .= "s.tel AS tel_societe, s.nom AS societe, count(id_notification) AS appels ";
		 $Query .= "FROM societe s, appelant a LEFT JOIN notification USING (id_appelant) ";
		 $Query .= "WHERE s.id_societe=a.id_societe ";
		 $Query .= "GROUP BY a.email,a.id_appelant,a.nom,a.tel,s.tel,a.code,a.tel,s.nom,a.id_societe ";
		 $Query .= "ORDER BY appels DESC, a.nom ASC";
		 $this->Query($Query);
		 $i=0;
		 $result = array ();
     while ($this->HasNext())
     {
       $result[$i]["nom"]         = $this->data["nom"];
       if ($this->data["tel_societe"] != NULL)
       {
         $result[$i]["tel"]       = $this->data["tel_societe"]." (S)";
       } else if ($this->data["tel"] != NULL) {
         $result[$i]["tel"]       = $this->data["tel"]." (A)";
       } else {
				 $result[$i]["tel"]				= "";
			 }
       $result[$i]["tel"]         = $this->Format_Tel($result[$i]["tel"]);
	     $result[$i]["id_societe"]  = $this->data["id_societe"];
	     $result[$i]["societe"]     = $this->data["societe"];
	     $result[$i]["email"]       = $this->data["email"];
	     $result[$i]["code"]        = $this->data["code"];
			 $result[$i]["id"]          = $this->data["id_appelant"];
			 $result[$i]["appels"]      = $this->data["appels"];
	     $i++;
	   }
	   return $result;
	 }
	 
	 /* Supprimer un appelant de la base donne grace a son id */
   function delappelant($id)
	 {
     if (!is_numeric($id)) { return False; }
		 $Query = "SELECT id_appelant FROM appelant WHERE id_appelant='".$id."'";
		 if (!$this->QueryRow($Query)) { return False; }
		 $Query = "DELETE FROM notification WHERE id_appelant='".$id."'";
		 if (!$this->Delete($Query)) { return False; }
		 $Query = "DELETE FROM appelant WHERE id_appelant='".$id."'";
		 return $this->Delete($Query);
	 }
	 
	 /* Modifie un appelant, grace a son id */
   function modifyappelant($id_appelant,$nom,$tel,$email,$code,$societe)
	 {
     $Query  = "UPDATE appelant SET nom='".$nom."',tel='".$tel."',email='".$email."' ";
		 $Query .= ",code='".$code."',id_societe='".$societe."' ";
		 $Query .= "WHERE id_appelant='".$id_appelant."'";
		 return $this->Update($Query);
	 }

	 /* rcupere les informations sur un appelant, grace a son id */
	 function Get_Appelant($id)
	 {
     $Query  = "SELECT * ";
		 $Query .= ",(SELECT nom FROM societe WHERE id_societe=appelant.id_societe) AS societe ";
     $Query .= ",(SELECT id_societe FROM societe WHERE id_societe=appelant.id_societe) AS id_societe ";		 
	   $Query .= "FROM appelant WHERE id_appelant='".$id."'";
		 $this->QueryRow($Query);
		 return $this->data;
	 }
	 
	 /* recherche le telephone de l'utilisateur "TRUC" ou ayant le code "TRUC" */ 
	 function Search_Tel ($search)	 {
     $Query  = "SELECT tel,id_societe FROM appelant ";
		 $Query .= "WHERE nom ILIKE '%".$search."%' OR code ILIKE '%".$search."%'";
     
		 $this->QueryRow($Query);
		 if (!$this->HasResult()) {
		   Debug(3,"Impossible de trouver ".$search);
			 return False;
		 }
		 $id_societe = $this->data["id_societe"];
		 if ($this->data["tel"] == NULL)
		 {
			 Debug(3,"Telephone pour ".$search." null, on prend celuis de la socit");
			 $Query  = "SELECT tel FROM societe ";
			 $Query .= "WHERE id_societe='".$this->data["id_societe"]."'";
			 $this->QueryRow($Query);
			 if (!$this->HasResult())
			 {
         Debug(3,"Impossible de trouver le tel de la societe ".$id_societe);
				 return False;
			 }
			 return $this->data["tel"];
		 } else {
			 return $this->data["tel"];
		 }
	 } // Search Tel

   function List_Operateurs()
	 {
     $Query  = "SELECT * FROM operateur";
		 $this->Query($Query);
		 $i=0;
		 $operateurs = array();
		 while ($this->HasNext())
		 {
			 $operateurs[$i]["id"]         = $this->data["id_operateur"];
       $operateurs[$i]["nom"]        = $this->data["nom"];
			 $operateurs[$i]["code"]       = $this->data["code"];
			 $operateurs[$i]["tel"]        = $this->Format_Tel($this->data["tel"]);
			 $operateurs[$i]["email"]      = $this->data["email"];
			 $operateurs[$i]["mail_notif"] = $this->data["mail_notif"];
			 $i++;
		 }
		 return $operateurs;
	 }

	 function Is_Operateur($nom)
	 {
		 $keywords = explode(" ",$nom);
		 $Query  = "SELECT id_operateur FROM operateur WHERE 0=0 ";
     if (count($keywords)>1)
     {
       for ($i=0;$i<count($keywords);$i++)
       {
         $Query .= "AND (nom ILIKE '%".$keywords[$i]."%' OR code ILIKE '%".$keywords[$i]."%') ";
       }
     } else {
	       $Query .= "AND (code ILIKE '%".$nom."%' OR nom ILIKE '%".$nom."%') ";
     }											 
		 $this->QueryRow($Query);
		 if (!$this->HasResult())  { return False; }
		 return $this->data["id_operateur"];
	 }
	 
	 function Get_Operateur($id)
	 {
     $Query = "SELECT * FROM operateur WHERE id_operateur='".$id."'";
		 if (!$this->QueryRow($Query)) { return False; }
		 return $this->data;
	 }
	 
	 function Add_Operateur($nom,$code,$tel,$email,$mail_notif)
	 {
     $Query  = "INSERT INTO operateur (nom,code,tel,email,mail_notif) ";
		 $Query .= "VALUES ('".$nom."','".$code."','".$tel."','".$email."','".$mail_notif."')";
		 return $this->Insert($Query);
	 }

	 function Modify_Operateur($id,$nom,$code,$tel,$email,$mail_notif)
	 {
     $Query  = "UPDATE operateur SET nom='".$nom."',code='".$code."',tel='".$tel."',email='".$email."',mail_notif='".$mail_notif."' WHERE id_operateur='".$id."'";
		 return $this->Update($Query);
	 }

	 function New_Appelant_Societe_Note($nom,$societe,$client,$code,$tel,$priorite,$message,$rappel)
	 {
		 if (empty($code)) { $code = $nom; }
     if (!$this->Add_Societe($societe,"",$societe,$client))
			 return False;
		 if (!$this->addappelant($nom,$this->Get_Societe_Id($societe),$tel,$email,$code))
		   return False;
		 return $this->AddNoteNom($nom,$tel,$priorite,$message,$rappel);
	 }

	 function Send_Mail($id)
	 {
		 $headers = NULL;
     $array = array ();
		 $array = $this->Get_Note($id);

		 $message  = "Date: ".$array["date"]."\n";
		 $message .= "Besoin de rappel : ";
     if ($array["a_rappeler"] == "t") { 
			 $message .= "Oui\n";
		 } else {
			 $message .= "Non\n";
		 }
		 $message .= "Notification provenant de : ".$array["nom"]."\n";
		 $message .= "Socit : ".$array["societe"]."\n";
		 $message .= "Priorit de l'appel : ".$array["priorite"]."\n";
		 $message .= "Telephone : ".$array["tel"]."\n\n";
		 $message .= "Oprateur : ".$array["operateur"]."\n";
		 for($i=0;$i<20;$i++) { $message .= "----"; }
		 $message .= "\n";
		 $message .= $array["contenu"]; 
     $subject = "[Clariphony]: ".$array["nom"];
		 
		 if ($array["mail_operateur"]) { 
			 $headers .= "From: ".$array["operateur"]." <".$array["mail_operateur"].">\n"; 
		 } else {
			 $headers .= "From: Clariphony <clariphony@clarisys.fr>\n";
		 }
		 
     if ($array["a_rappeler"] == "t") { $subject .= " [Besoin de RAPPEL]"; }

		 $Query  = "SELECT email FROM operateur WHERE mail_notif='t'";
		 $this->Query($Query);
		 if (!$this->HasResult()) { return; }
		 $this->HasNext();
		 $to = $this->data["email"];
		 if ($this->HasNext()) { $headers .= "Cc: ".$this->data["operateur"]." <".$this->data["email"].">\n"; }
		 while ($this->HasNext())
		 {
			 $headers .= ",".$this->data["operateur"]." <".$this->data["email"].">\n";
		 }
     $headers .= "X-Mailer: Clariphony\n";		 
		 Debug(3,"Envoie un mail a ".$to." headers: ".$headers);
		 mail ($to,$subject,$message,$headers);
	 }
}
