<?php

/*************************************************************\
 * Code par Laurent Coustet "ed" <ed@debian-fr.net>          *
 * Ce code sous sous licence GPL.                            *
 * --------------------------------------------------------- *
 *          Copyright (c) 2004 Clarisys.fr                   *
\*************************************************************/

/* Fonctions de debug (classes impossibles...)
 * Une gestion du niveau d'utilisateur doit elle tre introduite ?
 * 
 * Plusieurs niveaux de debug:
 *
 * - 3 => Tout est affich.
 * - 2 => Messages sensibles uniquements.
 * - 1 => Erreurs Seulement.
 * - 0 => Pas de debug
 */

$dbg_messages= array();
$dbg_level=0;
$dbg_level_lng = array ("Pas de debug.",
			"Erreurs seulement.",
			"Messages sensibles seulement",
			"Tout est affich.");
  
/* Void Set_Debug_Level($level)
 * Cette fonction modifie le niveau de debug actuel.
 */
function Set_Debug_Level ($level)
{
  global $dbg_level;
  $dbg_level = $level;
  Debug (2,"Mise en place du debug niveau ". $level .".");
  return;
}

/* Void Return_Debug_Level ();
 * Cette fonction renvoie le niveau courrant de debug
 */
function Return_Debug_Level ($lvl="unset")
{
  global $dbg_level_lng,$dbg_level;
  if ($lvl == "unset")
    {
      return $dbg_level_lng[$dbg_level];
    }
  else
    {
      return $dbg_level_lng[$lvl];
    }
}


/* Void Debug (level,message);
 * Cette fonction ajoute au tableau des messages de debug
 * avec la priorite $lvl.
 */
function Debug ($lvl,$message)
{
  global $dbg_messages;
  if (!is_array($dbg_messages[$lvl]))
    {
      $dbg_messages[$lvl] = array ();
    }
  array_push ($dbg_messages[$lvl],$message);
  return;
} /* Debug ($message) */


/* Void Flush_Debug ();
 * Cette fonction permet de vider les messages de debug prsents
 */
function Flush_Debug ()
{
  global $dbg_messages;
  unset ($dbg_messages);
  return;
} /* Flush_Debug () */


/* Void function Print_Array_Debug ();
 * Cette fonction affiche simplement tout les messages de debug.
 */
function Print_Array_Debug ()
{
  global $dbg_messages,$dbg_level;
  $buffer  = "";
  $buffer .= "Messages de debug:<ul>\n";
  foreach ($dbg_messages as $lvl => $tmp)
    {
      if ($dbg_level >= $lvl)
	{
	  $buffer .= "<li>Niveau: ".$lvl.": ".Return_Debug_Level($lvl)."\n</li>\n<ul>";
	  foreach ($tmp as $number => $message)
	    {
	      $buffer .= "<li>[".$number."] -> [".$message."]</li>\n";
	    }
	  
	  $buffer .= "</ul>\n";
	}
    }
  $buffer .= "</ul>\n";
  return $buffer;
}

?>
