<?php

/*************************************************************\
 * Code par Laurent Coustet "ed" <ed@debian-fr.net>          *
 * Ce code sous sous licence GPL.                            *
 * --------------------------------------------------------- *
 *          Copyright (c) 2004 Clarisys.fr                   *
\*************************************************************/
    
class pgsql
{
  var $db, $pgsql_id, $result, $rows, $data, $a_rows, $rowsperpage;
  var $currentrow, $currentpage, $startrow, $endrow, $insertedid;
  
	/* cette fonction se connecte a la base de donne PostgreSQL
	 * retourne l'id de connexion si la connexion est tablie
	 * False si c'est un chec
	 */
  function Init_db ($host, $user, $pass, $db) 
  {
    /* on utiliser @ pour ne pas avoir les messages d'erreurs. */
    $this->pgsql_id = @pg_connect("user=".$user." password=".$pass." host=".$host." dbname=".$db);
		/* TODO: Gestion des pconnect */
    if($this->pgsql_id == false)
  	{
	    Debug (1,"Impossible d'tablir la connexion avec ". $host ." en tant que " .$user);
			return False;
  	}
	    Debug (2,"Connexion tablie (PostgreSQL) avec ". $host ." en tant que " .$user);
      return $this->pgsql_id;
    }
  
  function Query ($query) 
  {
    $this->ResetValues();
    Debug (3,"Execution d'une requete SQL: $query");
    if (!$this->result = pg_query($this->pgsql_id, $query)) {
      Debug (1,"Impossible d'executer: $query");
	  	Debug (1,"Erreur PostgreSQL: ".pg_last_error($this->pgsql_id));
			return False;
		}
    $this->rows = pg_num_rows($this->result);
  }
  
  function QueryItem ($query) 
  {
    $this->ResetValues();
    Debug (3,"Execution d'une requete SQL: $query");
    if (!$this->result = @pg_query($this->pgsql_id, $query)) {
    	Debug (1,"Impossible d'executer: $query");
	  	Debug (1,"Erreur PostgreSQL: ".pg_last_error($this->pgsql_id));
		}
    $this->rows = @pg_num_rows($this->result);
    if($this->rows>0)
	  {
	    if (!$this->data = @pg_fetch_array($this->result)) {
  		  Debug (1,"Impossible d'executer: $query");
			  Debug (1,"Erreur PostgreSQL: ".pg_last_error($this->pgsql_id));
				return False;
			}
	    return($this->data[0]);
	  } else {
  	  return False;
	  }
  }
  
  function QueryRow ($query) 
  {
    $this->ResetValues();
    Debug (3,"Execution d'une requete SQL: $query");
    if (!$this->result = pg_query($this->pgsql_id,$query)) {
      Debug (1,"Impossible d'executer: $query");
	  	Debug (1,"Erreur PostgreSQL: ".pg_last_error($this->pgsql_id));
			return False;
		}
    $this->rows = @pg_num_rows($this->result);
    if($this->rows>0)
    {
 	    if (!$this->data = pg_fetch_array($this->result)) {
		    Debug (1,"Impossible d'executer: $query");
				Debug(1,"Erreur PostgreSQL: ".pg_last_error($this->pgsql_id));
				return False;
			}
	    return($this->data);
  	} else {
	    return False;
 	  }
  }
  
  function Insert ($query) 
  {
    Debug (3,"Execution d'une requete SQL: $query");
    if(!($this->result = pg_query($this->pgsql_id,$query)))
  	{
	    Debug (1,"Impossible d'executer: $query");
			Debug (1,"Erreur PostgreSQL: ".pg_last_error($this->pgsql_id));
	    return False;
  	}
      $this->a_rows = @pg_affected_rows($this->result);
//      $this->insertedid = pg_insert_id($this->pgsql_id);
//			Debug(3,"Inserted id: ".$this->insertedid);
      return True;
    }
  
  function Update ($query) 
  {
    Debug (3,"Execution d'une requete SQL: $query");
    if (!$this->result = @pg_query($this->pgsql_id, $query)) {
  	  Debug (1,"Impossible d'executer: $query");
	  	Debug (1,"Erreur PostgreSQL: ".pg_last_error($this->pgsql_id));
			return False;
		}
    $this->a_rows = @pg_affected_rows($this->result);
		return True;
  }
  
  function Delete ($query) 
  {
    Debug (3,"Execution d'une requete SQL: $query");
    if (!$this->result = @pg_query($this->pgsql_id, $query)) {
    	Debug (1,"Impossible d'executer: $query");
	  	Debug (1,"Erreur PostgreSQL: ".pg_last_error($this->pgsql_id));
			return False;
		}
    $this->a_rows = @pg_affected_rows($this->result);
		return True;
  }
  
  function Fetch ($row) 
  {
    if (!@pg_result_seek($this->result, $row))
		{
       Debug (1,"Impossible d'executer Fetch($row)");
   	 	 Debug (1,"Erreur PostgreSQL: ".pg_last_error($this->pgsql_id));
			 return False;
		}
    if (!$this->data = @pg_fetch_array($this->result))
		{
 	    Debug (1,"Impossible d'executer Fetch($row)");
		  Debug (1,"Erreur PostgreSQL: ".pg_last_error($this->pgsql_id));
		  return False;
		}
  }
  
  function HasNext()
  {
    if($this->currentrow<$this->rows)
    {
	    $this->Fetch($this->currentrow++);
	    return $this->currentrow;
	  } else {
	    return False;
	  }
  }
  
  function ResetValues()
  {
    Debug (3,"ResetValues() executed");
    $this->currentrow = 0;
    $this->endrow = 0;
  }
  
  function HasResult()
  {
    if($this->rows > 0)
	  {
  	  return True;
	  } else  {
	    return False;
  	}
  }
  
} /* PostgreSQL_CLASS */

?>
